#include <iostream>
#include <vector>
#include <fstream>
#include <sstream>
#include <string>

//#define DELTA_T 2e-3

using namespace std;


int main(int argc, char* argv[])
{
	int nr_data = 0;
	
	if(argc != 4)
	{
		cerr << "Usage:\n\t" << argv[0] << " conffile lower_bound upper_bound\n";
		return 1;
	}
	
	ifstream conffile(argv[1]);
	
	double lower_bound=atof(argv[2]);
	double upper_bound=atof(argv[3]);
	
	if(!conffile)
	{
		cerr << argv[0] << " error: unable to open " << argv[1] << endl;
		return 1;
	}
	
	vector< vector<double> > data;
	string line;
	
	double d;
//	conffile >> d;
	
	
	
	while(getline(conffile, line))
	{
		if(line.length() == 0 || line.at(0) == '#')
			continue;
		
//		cerr << line << "\n";
		
		vector<double> *d_tmp = new vector<double>(8);
		
		istringstream iss(line);
		data.push_back(*d_tmp);
		
		for(int i=0; i<8; ++i)
		{
			iss >> d;
			data[nr_data][i] = d;
		}
		
		++nr_data;
	}
	
	conffile.close();
	
//	cout << "Nr. of data: " << nr_data << "\t" << data.size() << "\n";
	
	
//	for(int i=0; i<nr_data; ++i)
//	{
//		for(int j=0; j<7; ++j)
//			cout << data[i][j] << "\t";
//		
//		cout << data[i][7] << "\n";
//		cout << i << "\t" << data[i].size() << "\n";
//	}
	
	double ms_energy = 0.0;
	double ms_time = 0.0;
	int in_sequence = 0;
	
	double time_min=1e-6;
	vector<double> time_bins(30);
	vector<int> time_bins_data(30);
	
	for(int i=0; i<30; ++i)
	{
		time_bins[i] = 0.0;
		time_bins_data[i] = 0;
	}
	
	double time=time_min;
/*	for(int i=0; i<30; ++i)
	{
		cout << i << "\t" << time << "\t" << time_bins[i] << "\t" << time_bins_data[i] << "\n";
		time *=2.0;
	}
*/	
	
	
	for(int i=0; i<nr_data; ++i)
	{
		if(data[i][7] >= lower_bound || i==nr_data-1) // end of a sequence
		{
			if(in_sequence == 1)
			{
				time=time_min;
				int j=0;
				while(time < (data[i-1][0] - ms_time) && j<30)
				{
//					if(j==0)
//						cout << time_bins_data[0] << "\t" << time << "\t" << data[i][0] - ms_time << "\t";
					time_bins_data[j] += 1;
//					if(j==0)
//						cout << time_bins_data[0] << "\n";
					time *= 2.0;
					++j;
				}
			}
			
			in_sequence = 0;
		}
		
		if(data[i][7] >= lower_bound && data[i][7] <= upper_bound) // a ms/beginning of a sequence
		{
			in_sequence = 1;
			ms_time = data[i][0];
			ms_energy = data[i][7];
		}
		
		if(in_sequence == 1 && data[i][7] < lower_bound) // in a sequence
		{
			time=time_min;
			int jj=0;
			while(time < (data[i][0] - ms_time) && jj<30-1)
			{
				time *= 2.0;
				++jj;
			}
			time_bins[jj] += 1.0;
		}
	}
	
	time=time_min;
	for(int i=0; i<30; ++i)
	{
		cout << i << "\t" << time << "\t" << time_bins[i] << "\t" << time_bins_data[i] << "\t" << time_bins_data[0] << "\n";
		time *=2.0;
	}
	
//	int cascade_id=0;
//	int cascade_begin=0;
//	
//	for(i=1; i<nr_data; ++i)
//	{
//		if(data[i][0]-data[i-1][0] < DELTA_T)
//		{
//			if(cascade_begin==1) // we're already in an avalanche
//			
//			cout << cascade_id << 
//			
//		}
//	}
	
/*	for(int i=0; i<nr_data; ++i)
		y[i] = y[i] - avg_y;
	
	
	vector<double> x_interpol, y_interpol;
	
	x_interpol.push_back(x[0]);
	y_interpol.push_back(y[0]);
	
	int i_curr=0;
	
	for(int i=1; i<nr_data; ++i)
	{
		double x_curr = x[0]+delta_x*i;
		
		while(x[i_curr]<x_curr)
			++i_curr;
		
		double d = (x[i_curr]-x_curr)/(x[i_curr]-x[i_curr-1]);
		
		x_interpol.push_back(x_curr);
		y_interpol.push_back(d*y[i_curr-1] + (1.0-d)*y[i_curr]);
	}
	
//	for(int i=0; i<nr_data; ++i)
//		cout << i << "\t" << x_interpol[i] << "\t" << y_interpol[i] << "\n";
	
	
	vector<double> autocorr(nr_data);
	
	for(int i=0; i<nr_data; ++i)
	{
		double sum = 0.0;
		for(int j=0; j<nr_data; ++j)
		{
			double d = y_interpol[j]*y_interpol[(j+i)%nr_data];
//			if(d >= 0.0)
				sum += d;
//			else
//				sum -= d;
		}
		
		autocorr[i] = sum/nr_data;
	}
	
	
	for(int i=0; i<nr_data; ++i)
		cout << i << "\t" << delta_x*i << "\t" << autocorr[i] << "\n";
*/	
	return 0;
}
